<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN"><HTML><HEAD><TITLE>80386 Programmer's Reference Manual -- Opcode MOVSX</TITLE> </HEAD><BODY><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="MOVS.htm"> MOVS/MOVSB/MOVSW/MOVSD Move Data from String to String</A><BR><B>next:</B><A HREF="MOVZX.htm"> MOVZX Move with Zero-Extend</A><P><HR><P><H1>MOVSX -- Move with Sign-Extend</H1><PRE>
Opcode     Instruction        Clocks   Description

0F  BE /r  MOVSX r16,r/m8     3/6      Move byte to word with sign-extend
0F  BE /r  MOVSX r32,r/m8     3/6      Move byte to dword, sign-extend
0F  BF /r  MOVSX r32,r/m16    3/6      Move word to dword, sign-extend
</PRE><H2>Operation</H2><PRE>
DEST := SignExtend(SRC);
</PRE><H2>Description</H2>MOVSX reads the contents of the effective address or register as a byte or a word, sign-extends the value to the operand-size attribute of the instruction (16 or 32 bits), and stores the result in the destination register.<H2>Flags Affected</H2>None<H2>Protected Mode Exceptions</H2>#GP(0) for an illegal memory operand effective address in the CS, DS, ES, FS or GS segments; #SS(0) for an illegal address in the SS segment; #PF(fault-code) for a page fault<H2>Real Address Mode Exceptions</H2>Interrupt 13 if any part of the operand would lie outside of the effective address space from 0 to 0FFFFH<H2>Virtual 8086 Mode Exceptions</H2>Same exceptions as in Real Address Mode; #PF(fault-code) for a page fault<P><HR><P><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="MOVS.htm"> MOVS/MOVSB/MOVSW/MOVSD Move Data from String to String</A><BR><B>next:</B><A HREF="MOVZX.htm"> MOVZX Move with Zero-Extend</A> </BODY>